module Evaluator where
open import Syntax
open import SyntacticLemmas
open import Variables
open import Value

mutual
  ev : forall {Γ Δ σ} -> Tm Δ σ -> (vs : Env Γ Δ) -> Val Γ (σ [ embˢ vs ]⁺)
  ev (coe t p)     vs        = coev (ev t (coevˢ vs reflˠ (symˠ(fog⁺ p)))) 
                                    (cong⁺ p (symˢ (cohvˢ vs _ _))) 
  ev (t [ ts ])    vs        = coev (ev t (evˢ ts vs)) 
                                    (trans⁺ (cong⁺ refl⁺ (symˢ (comevˢ ts vs)))
                                            (sym⁺ assoc⁺)) 
  ev top           (vs << v) = coev v (trans⁺ (cong⁺ refl⁺ (symˢ pop<)) 
                                              (sym⁺ assoc⁺)) 
  ev (λ t)         vs        = λv t vs 
  ev (app f)       (vs << v) = vapp (ev f vs) refl⁺ v  
  ev (Πu σ τ)      vs        = Πuv σ τ vs
  ev (bot p ρ)     vs        = nev (botn p (ρ [ embˢ vs ]⁺))

  evˢ : forall {Γ Δ Σ} -> Sub Δ Σ -> Env Γ Δ -> Env Γ Σ
  evˢ (coeˢ ts p q) vs       = coevˢ (evˢ ts (coevˢ vs reflˠ (symˠ p))) reflˠ q
  evˢ (ts • us)     vs       = evˢ ts (evˢ us vs)
  evˢ id            vs       = vs
  evˢ (pop σ)      (vs << v) = vs
  evˢ (ts < t)     vs        =
    evˢ ts vs << coev (ev t vs) (trans⁺ assoc⁺ (cong⁺ refl⁺ (comevˢ ts vs)))

  vapp : forall {Γ Γ' Δ σ τ ρ}{ts : Sub Γ Δ} -> Val Γ' ρ ->
         ρ ≡⁺ (Π σ τ [ ts ]⁺) ->
         (v : Val Γ (σ [ ts ]⁺)) -> Val Γ (τ [ ts < emb v ]⁺)
  vapp (λv t vs)    p a = 
    coev (ev t (vs << coev a (sym⁺ (dom (trans⁺ (sym⁺ Π[]) (trans⁺ p Π[])))))) 
         (inst (cod (trans⁺ (sym⁺ Π[]) (trans⁺ p Π[]))) (coh _ _))
  vapp (nev n)      p a = nev (coen (app (coen (coen n p) Π[]) a) 
                              (trans⁺ assoc⁺ (cong⁺ refl⁺ popid))) 
  vapp (coev v p)   q a = vapp v (trans⁺ p q) a 
  vapp {σ = σ'}{τ = τ'}{ts = ts}(Πuv σ τ vs) p a = nev (coen (app (botn (trans⁺ (sym⁺ U[]) (trans⁺ p Π[])) (Π (σ' [ ts ]⁺) (τ' [ ts ↗ σ' ]⁺))) a) (trans⁺ assoc⁺ (cong⁺ refl⁺ popid)))
{-
    nev (botn (trans⁺ (sym⁺ U[]) (trans⁺ p Π[])) 
              (_ [ _ < emb a ]⁺))
-}
  comev : forall {Γ Δ σ}(t : Tm Δ σ)(vs : Env Γ Δ) ->
        t [ embˢ vs ] ≡ emb (ev t vs)
  comev (coe t p)     vs        = trans (trans (cong (coh _ _) (cohvˢ vs _ _)) 
                                               (comev t (coevˢ vs _ _))) 
                                        (sym (coh _ _)) 
  comev (t [ ts ])    vs        = trans (trans (trans assoc 
                                                    (cong refl (comevˢ ts vs)))
                                               (comev t (evˢ ts vs))) 
                                      (sym (coh _ _)) 
  comev top           (vs << v) = trans top< (sym (coh _ _))
  comev (λ t)         vs        = refl 
  comev (app f)       (vs << v) = 
    trans (trans (trans (trans (trans (cong refl (symˢ popid)) (sym assoc))
                               (cong (sym app[]) reflˢ))
                        (cong (congapp (trans (trans (trans (coh _ Π[]) 
                                                            (comev f vs))
                                                     (sym (coh _ _)))
                                       (sym (coh _ _))))
                              reflˢ))
                 (sym (coh _ _)))
           (comvapp (ev f vs) refl⁺ v)
  comev (Πu σ τ)      vs        = refl 
  comev (bot p ρ)     vs        = bot[] 

  comevˢ : forall {Γ Δ Σ}(ts : Sub Δ Σ)(vs : Env Γ Δ) ->
         ts • embˢ vs ≡ˢ embˢ (evˢ ts vs)
  comevˢ (coeˢ ts p q) vs        = transˢ (transˢ (cong• (cohˢ ts _ _)
                                                       (cohvˢ vs _ _))
                                                (comevˢ ts _)) 
                                        (cohvˢ (evˢ ts _) _ _)  
  comevˢ (ts • us)     vs        = transˢ (transˢ assocˢ
                                                (cong• reflˢ (comevˢ us vs))) 
                                        (comevˢ ts (evˢ us vs)) 
  comevˢ id            vs        = leftid 
  comevˢ (pop σ)       (vs << v) = pop< 
  comevˢ (ts < t)      vs        = transˢ •< 
                                        (cong< (comevˢ ts vs)
                                               (ir (comev t vs))) 

  comvapp : forall {Γ Γ' Δ σ τ ρ}{ts : Sub Γ Δ}
         (f : Val Γ' ρ)(p : ρ ≡⁺ Π σ τ [ ts ]⁺) ->
         (v : Val Γ (σ [ ts ]⁺)) ->
         coe (emb f) p $ˢ emb v ≡ emb (vapp f p v)
  comvapp (λv t vs)  p a = 
    ir 
      (trans 
        (trans 
          (cong 
            (trans 
              (congapp 
                (trans 
                  (coh _ _) 
                  (trans (coh _ _) (trans (sym (coh _ Π[])) 
                (trans λ[] refl)))))
              (trans β (sym (coh _ (cod (trans⁺ (sym⁺ Π[]) (trans⁺ p Π[])))))))
            reflˢ)
          (trans 
            (cong 
              (coh _ _) 
              (cong< 
                (congid (symˠ (fog⁺ p)))
                (cong 
                  (sym 
                    (coh _ (dom (trans⁺ (sym⁺ Π[]) (trans⁺ (sym⁺ p) Π[]))))) 
                  (congid (symˠ(fog⁺ p))))))
            (trans assoc (cong refl (transˢ popid (cong< reflˢ (ir refl)))))))
        (comev t (vs << coev a _))) 
  comvapp (nev n)    p a = ir refl 
  comvapp (coev v p) q a = trans (ir (cong (congapp (ir (ir (coh _ _)))) 
                                           reflˢ))
                                 (comvapp v (trans⁺ p q) a)
  comvapp (Πuv σ τ vs) p a = ir (trans (cong (congapp (trans (coh _ _) (ir Πu[]))) reflˢ) (botapp (trans⁺ (sym⁺ U[]) (trans⁺ p Π[])))) 

vEl : forall {Γ Γ' Δ ρ}{ts : Sub Γ Δ} -> Val Γ' ρ -> ρ ≡⁺ U [ ts ]⁺ -> VTy Γ
vEl (Πuv σ τ vs) p = VΠ (El σ) (El τ) (coevˢ vs (fog⁺ p) reflˠ)
vEl (λv t vs)    p = NEl (botn (trans⁺ (sym⁺ U[]) (trans⁺ (sym⁺ p) Π[])) U) 
vEl (nev n)      p = NEl (coen n (trans⁺ p U[])) 
vEl (coev v p)   q = vEl v (trans⁺ p q) 

comvEl : forall {Γ Γ' Δ ρ}{ts : Sub Γ Δ}(v : Val Γ' ρ)(p : ρ ≡⁺ U [ ts ]⁺) ->
         Elˢ (coe (emb v) p) ≡⁺ emb⁺ (vEl v p)

comvEl (Πuv σ τ vs) p = -- this could benefit from some underscores
  trans⁺ (trans⁺ (congEl reflˠ (trans (coh _ U[]) (trans (coh _ p) (trans Πu[] (congΠu (fog⁺ p) (trans (coh _ U[]) (sym (coh (σ [ embˢ vs ]) (trans⁺ U[] (congU (fog⁺ p)))))) (trans (coh _ U[]) (sym (coh (τ [ embˢ vs • pop (El (coe (σ [ embˢ vs ]) U[])) < coe top (trans⁺ (cong⁺ (sym⁺ El[]) reflˢ) assoc⁺) ]) (trans⁺ U[] (congU (cong, (fog⁺ p) (congEl (fog⁺ p) (trans (coh (σ [ embˢ vs ]) U[]) (sym (coh (σ [ embˢ vs ]) (trans⁺ U[] (congU (fog⁺ p))))))))))))))))))
                 (trans⁺ rule⁺ (congΠ (trans⁺ (congEl reflˠ (trans (coh (σ [ embˢ vs ]) (trans⁺ U[] (congU (fog⁺ p)))) (trans (cong refl (cohvˢ vs (fog⁺ p) reflˠ)) (sym (coh (σ [ embˢ (coevˢ vs (fog⁺ p) reflˠ) ]) U[])) ) )) (sym⁺ El[])) (trans⁺ (congEl (cong, reflˠ (trans⁺ (congEl reflˠ (trans (coh (σ [ embˢ vs ]) (trans⁺ U[] (congU (fog⁺ p)))) (trans (cong refl (cohvˢ vs (fog⁺ p) reflˠ)) (sym (coh (σ [ embˢ (coevˢ vs (fog⁺ p) reflˠ) ]) U[]))) ) ) (sym⁺ El[]))) (ir (cong refl (cong< (cong• (cohvˢ vs (fog⁺ p) reflˠ) (congpop (trans⁺ (sym⁺ El[]) (cong⁺ refl⁺ (cohvˢ vs (fog⁺ p) reflˠ))))) (ir (congtop (trans⁺ (sym⁺ El[]) (cong⁺ refl⁺ (cohvˢ vs (fog⁺ p) reflˠ))))))))) (sym⁺ El[])))))
         (sym⁺ Π[]) 
comvEl (λv t vs)   p = trans⁺ (congEl reflˠ (trans (coh _ _) (trans (ir refl) (trans λ[] (sym (coh _ _)))))) (sym⁺ (botEl (trans⁺ (sym⁺ U[]) (trans⁺ (sym⁺ p) Π[])))) 
comvEl (nev n)     p = congEl reflˠ (ir (coh _ _))
comvEl (coev v p)  q = trans⁺ (congEl reflˠ (ir (ir (coh _ _))))
                              (comvEl v (trans⁺ p q))

ev⁺ : forall {Γ Δ} -> Ty Δ -> Env Γ Δ -> VTy Γ
ev⁺ (coe⁺ σ p)  vs = ev⁺ σ (coevˢ vs reflˠ (symˠ p))
ev⁺ (σ [ ts ]⁺) vs = ev⁺ σ (evˢ ts vs)
ev⁺ U          vs = VU
ev⁺ (El t)     vs = vEl (ev t vs) refl⁺ 
ev⁺ (Π σ τ)    vs = VΠ σ τ vs

comev⁺ : forall {Γ Δ}(σ : Ty Δ)(vs : Env Γ Δ) ->
         σ [ embˢ vs ]⁺ ≡⁺ emb⁺ (ev⁺ σ vs)
comev⁺ (coe⁺ σ p)  vs =
  trans⁺ (cong⁺ (coh⁺ _ _) (cohvˢ vs _ _))
        (comev⁺ σ (coevˢ vs reflˠ (symˠ p)))
comev⁺ (σ [ ts ]⁺) vs =
  trans⁺ assoc⁺ (trans⁺ (cong⁺ refl⁺ (comevˢ ts vs)) (comev⁺ σ (evˢ ts vs)))
comev⁺ U          vs = U[]
comev⁺ (El σ)     vs = 
  trans⁺ (trans⁺ El[] (congEl reflˠ 
                              (ir (trans (comev σ vs) (sym (coh _ _)))))) 
         (comvEl (ev σ vs) refl⁺)
comev⁺ (Π σ τ)    vs = refl⁺
